/*
 * _program_mode.h
 *
 *  Created on: Sep 29, 2023
 *  Author: r9ofg.ru
 */

#ifndef INC__PROGRAM_MODE_H_
#define INC__PROGRAM_MODE_H_

/*  */

#include <main.h>

/*  */

#define _PROGRAM_DEF	"  \n"
#define _RELEASE_DEF	": 1.0 beta\n"
#define _COPYRIGHT_DEF	"R9OFG.RU 01/2024\n"

#define LED_DISP_set()		LED_DISP_GPIO_Port->BSRR = (uint32_t)LED_DISP_Pin<<16u; // . 1
#define LED_DISP_reset()	LED_DISP_GPIO_Port->BSRR = LED_DISP_Pin;			    // . 0

#define LED_PTT_set()		LED_PTT_GPIO_Port->BSRR = (uint32_t)LED_PTT_Pin<<16u; 	// . 1
#define LED_PTT_reset()		LED_PTT_GPIO_Port->BSRR = LED_PTT_Pin;				    // . 0

#define A_reset() 			A_CODE_GPIO_Port->BSRR = (uint32_t)A_CODE_Pin<<16u; 	// . 1
#define A_set()   			A_CODE_GPIO_Port->BSRR = A_CODE_Pin;				  	// . 0
#define B_reset() 			B_CODE_GPIO_Port->BSRR = (uint32_t)B_CODE_Pin<<16u; 	// . 1
#define B_set()   			B_CODE_GPIO_Port->BSRR = B_CODE_Pin;				  	// . 0
#define C_reset() 			C_CODE_GPIO_Port->BSRR = (uint32_t)C_CODE_Pin<<16u; 	// . 1
#define C_set()   			C_CODE_GPIO_Port->BSRR = C_CODE_Pin;					// . 0
#define D_reset() 			D_CODE_GPIO_Port->BSRR = (uint32_t)D_CODE_Pin<<16u; 	// . 1
#define D_set()   			D_CODE_GPIO_Port->BSRR = D_CODE_Pin;				  	// . 0

#define PE_V1_reset()		PE_V1_GPIO_Port->BSRR = (uint32_t)PE_V1_Pin<<16u; 		// . 1
#define PE_V1_set()			PE_V1_GPIO_Port->BSRR = PE_V1_Pin;				  		// . 0
#define PE_V2_reset()		PE_V2_GPIO_Port->BSRR = (uint32_t)PE_V2_Pin<<16u; 		// . 1
#define PE_V2_set()			PE_V2_GPIO_Port->BSRR = PE_V2_Pin;				  		// . 0
#define PE_V3_reset()		PE_V3_GPIO_Port->BSRR = (uint32_t)PE_V3_Pin<<16u; 		// . 1
#define PE_V3_set()			PE_V3_GPIO_Port->BSRR = PE_V3_Pin;				  		// . 0
#define PE_V4_reset()		PE_V4_GPIO_Port->BSRR = (uint32_t)PE_V4_Pin<<16u; 		// . 1
#define PE_V4_set()			PE_V4_GPIO_Port->BSRR = PE_V4_Pin;				  		// . 0
#define PE_V5_reset()		PE_V5_GPIO_Port->BSRR = (uint32_t)PE_V5_Pin<<16u; 		// . 1
#define PE_V5_set()			PE_V5_GPIO_Port->BSRR = PE_V5_Pin;				  		// . 0
#define PE_V6_reset()		PE_V6_GPIO_Port->BSRR = (uint32_t)PE_V6_Pin<<16u; 		// . 1
#define PE_V6_set()			PE_V6_GPIO_Port->BSRR = PE_V6_Pin;				  		// . 0

/*  */

typedef enum {
	PROG_STATE_WORK	 		= 0, // 
	PROG_STATE_SETUP		= 1, // 
	PROG_STATE_CALIBRATE	= 2	 // 
} PROG_STATE;

typedef enum {
	NO_BUT					= 0, //    
	BUT_FUNCTION			= 1, // 
	BUT_LEFT 				= 2, // 
	BUT_RIGHT				= 3  // 
} BUTTON_PRESS;

typedef enum {
	OFF						= 0, // 
	ON						= 1  // 
} SETUP_PA_PARAM;

typedef enum {
	_160					= 0, //160m
	_80						= 1, //80m
	_40						= 2, //40m
	_30						= 3, //30m
	_20						= 4, //20m
	_17						= 5, //17m
	_15						= 6, //15m
	_12						= 7, //12m
	_10						= 8  //10m
} BAND_INDEX;

typedef enum {
	_50						= 50, //50
	_75						= 75  //75
} Z_VALUE;

/*  */

struct SETUP_PA {
	/*    */
	SETUP_PA_PARAM 			SET_LED_DISPLAY;
	SETUP_PA_PARAM 			SET_CHANGE_POWER;
	SETUP_PA_PARAM 			SET_EXT_CONTROL_LPF;
	uint8_t	   	   			SET_Z;
};

/*   */

void READ_setup_pa();
void LPF_change_band();
void PE4302_change_att(uint8_t param);
void PROG_mode();
void PROG_mode_work();
void PROG_mode_setup();
void PROG_mode_calibrate();

void Splash();

#endif /* INC__PROGRAM_MODE_H_ */
