/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32f1xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/*   */
void ADC_1_start_conversion(void);
void GET_adc_channel_value(void);

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define LED_PTT_Pin GPIO_PIN_13
#define LED_PTT_GPIO_Port GPIOC
#define A_CODE_Pin GPIO_PIN_0
#define A_CODE_GPIO_Port GPIOB
#define B_CODE_Pin GPIO_PIN_1
#define B_CODE_GPIO_Port GPIOB
#define LCD_CS_Pin GPIO_PIN_10
#define LCD_CS_GPIO_Port GPIOB
#define LCD_RST_Pin GPIO_PIN_11
#define LCD_RST_GPIO_Port GPIOB
#define LCD_DC_Pin GPIO_PIN_12
#define LCD_DC_GPIO_Port GPIOB
#define LED_DISP_Pin GPIO_PIN_13
#define LED_DISP_GPIO_Port GPIOB
#define C_EXT_Pin GPIO_PIN_14
#define C_EXT_GPIO_Port GPIOB
#define D_EXT_Pin GPIO_PIN_15
#define D_EXT_GPIO_Port GPIOB
#define PE_V1_Pin GPIO_PIN_8
#define PE_V1_GPIO_Port GPIOA
#define PE_V2_Pin GPIO_PIN_9
#define PE_V2_GPIO_Port GPIOA
#define PE_V3_Pin GPIO_PIN_10
#define PE_V3_GPIO_Port GPIOA
#define A_EXT_Pin GPIO_PIN_11
#define A_EXT_GPIO_Port GPIOA
#define B_EXT_Pin GPIO_PIN_12
#define B_EXT_GPIO_Port GPIOA
#define PTT_ON_Pin GPIO_PIN_15
#define PTT_ON_GPIO_Port GPIOA
#define PTT_ON_EXTI_IRQn EXTI15_10_IRQn
#define C_CODE_Pin GPIO_PIN_3
#define C_CODE_GPIO_Port GPIOB
#define D_CODE_Pin GPIO_PIN_4
#define D_CODE_GPIO_Port GPIOB
#define PE_V4_Pin GPIO_PIN_5
#define PE_V4_GPIO_Port GPIOB
#define PE_V5_Pin GPIO_PIN_8
#define PE_V5_GPIO_Port GPIOB
#define PE_V6_Pin GPIO_PIN_9
#define PE_V6_GPIO_Port GPIOB

/* USER CODE BEGIN Private defines */

#define ADC_CHANNELS_NUM	4

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
