/*
 * _prog_process.c
 *
 *  Created on: Sep 29, 2023
 *  Author: r9ofg.ru
 */

/*  */

#include <stdio.h>

#include "_program_mode.h"
#include "ina226_r9ofg.h"
#include "gmg12864_r9ofg.h"
#include "Float_transform.h"

/*   */

BUTTON_PRESS lastButton			= NO_BUT;			//  

PROG_STATE 	 PROG_state			= PROG_STATE_WORK;	//   
BUTTON_PRESS BUT_press			= NO_BUT;			//  

BAND_INDEX LPF_active			= _80;				//    (    LPF_band_string),       +1

char LPF_band_string[9][5]		= {{"160\n"},{"80\n"},{"40\n"},{"30\n"},{"20\n"},{"17\n"},{"15\n"},{"12\n"},{"10\n"}};	//   
char MENU_index[4][14]			= {{"\n"},{". \n"},{". \n"}, {" Z\n"}};						//  
char MENU_param_index[4][5]		= {{"\n"},{"\n"},{"\n"},{"ABCD\n"}}; 												//     RUS
char CALIBRATE_index[2][15]		= {{" INA226:\n"},{" ASC712:\n"}};													//   

volatile uint8_t sel_param 		= 0;				//   
volatile uint8_t sel_work_param = 0;				//     
volatile uint8_t flag_ptt_on	= 0;				//   PTT
volatile uint8_t att_data 		= -1;				//   PE4302

float rawFor 					= 0;				//    FOR
float rawRef					= 0;				//    REF
float powerFor					= 0;				//  
float powerRef					= 0;				//  
float currentPwr				= 0;				//      

/*  */

struct SETUP_PA Settings_PA;						//   

/*    */

extern uint8_t 	INA226_I2C_ADDRESS;
extern float  	vbus_calibrate;

extern uint8_t  lastPxString_X;
extern uint8_t  end_adc_flag;
extern uint8_t  end_adc_filter_flag;
extern uint16_t adc_values[ADC_CHANNELS_NUM];
extern uint16_t adc_out[ADC_CHANNELS_NUM];

extern float 	valueU;

extern uint8_t 	sign_number;
extern int 		integer_number;
extern uint32_t fractional_number;

/*-----------------------------------------------------------------*/

/*      */
BUTTON_PRESS GET_button(uint16_t Value)
{
	if ((Value > 2700) && (Value < 2800)) 		// ">"
	{
		return  BUT_LEFT;
	}
	else if ((Value > 2000) && (Value < 2100)) 	// "<"
	{
		return BUT_RIGHT;
	}
	else if (Value < 50) 						// "F"
	{
		return BUT_FUNCTION;
	}
	else
	{
		return NO_BUT;
	}
}

/*    */
void READ_button()
{
	{
		/*   */

		volatile static uint8_t buttonClk = 0; //  

		BUTTON_PRESS tempButton = GET_button(adc_values[0]);

		if (tempButton != lastButton)
		{
			buttonClk = 0;
		}
		else
		{
			//        
			if (buttonClk < 255) {buttonClk++;}
			if (buttonClk == 2) {BUT_press = tempButton;}
		}

		//   
		lastButton = tempButton;

		HAL_Delay(10);
	}
}

/*-----------------------------------------------------------------*/

/*  /   */
void LED_display(SETUP_PA_PARAM Value)
{
	switch (Value)
	{
		//  
		case OFF: LED_DISP_set();
		break;
		//  
		case ON: LED_DISP_reset();
		break;
	}
}

/*-----------------------------------------------------------------*/

/*   /  */
void GET_power()
{
	//    -1  FOR(ADC1_IN3)  REF (ADC1_IN4)
	rawFor = (float)adc_out[1] * 3.3 / 4095.0;
	rawRef = (float)adc_out[2] * 3.3 / 4095.0;

	float Kpwr = 350.0; //    

	//   FORWARD
	powerFor = rawFor * rawFor / Settings_PA.SET_Z * Kpwr;

	//   REFLECTED
	powerRef = rawRef * rawRef / Settings_PA.SET_Z * Kpwr;

	//   
	currentPwr = powerFor - powerRef;
	if(currentPwr < 0) {currentPwr = 0;}
}

/*-----------------------------------------------------------------*/

/*        */
void SWR_measurement()
{
	char strValueSwr[16] = "";
	float valueSwr		 = 0;

	if((flag_ptt_on != 1)||(currentPwr < 1))
	{
		//       1w?   = ---
		sprintf((char*)&strValueSwr, "---\n");
	}
	else
	{
		// ,  

		valueSwr = (rawFor + rawRef) / (rawFor - rawRef) * 1.1;

		//       Float_transform
		Float_transform(valueSwr, 2, &sign_number, &integer_number, &fractional_number);
		if (!sign_number)
		{
			if(integer_number >= 10)
			{
				//  10,  "---"
				//sprintf((char*)&strValueSwr, "---\n");
				//  10,  9.99
				sprintf((char*)&strValueSwr, "%d.%.02d\n", 9, 99);
			}
			else if(integer_number < 10)
			{
				//  10
				if(integer_number > 0)
				{
					sprintf((char*)&strValueSwr, "%d.%.02ld\n", integer_number, fractional_number);
				}
			}
		}
		else // 
		{
			sprintf((char*)&strValueSwr, "---\n");
		}
	}

	//  
	LCD_Output_String(90, 13, strValueSwr, 0, ChUnInvers);

	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 13, LCD_Width - 1, 10, pxView_Off);
}

/*      */
void POWER_measurement()
{
	char strValuePwr[7] = "";

	if(flag_ptt_on != 1)
	{
		// 

		//  = ---
		sprintf((char*)&strValuePwr, "---\n");

		SWR_measurement();
	}
	else
	{
		//    
		GET_power();

		//   0,      
		if(currentPwr > 0) {SWR_measurement();}

		//       Float_transform
		Float_transform(currentPwr, 1, &sign_number, &integer_number, &fractional_number);
		if (!sign_number)
		{
			sprintf((char*)&strValuePwr, "%d.%.01ld\n", integer_number, fractional_number);
		}
	}

	//           
	if ((Settings_PA.SET_CHANGE_POWER == ON)&&(flag_ptt_on != 0))
	{
		// 
		LCD_Draw_Rectangle_Filled(87, 1, LCD_Width - 1, 10, pxView_On);

		//  
		LCD_Output_String(90, 1, strValuePwr, 0, ChInvers);

		//  
		LCD_Draw_Rectangle_Filled(lastPxString_X, 1, LCD_Width - 1, 10, pxView_On);
	}
	else
	{
		// 
		LCD_Draw_Rectangle_Filled(87, 1, LCD_Width - 1, 10, pxView_Off);

		// 
		LCD_Output_String(90, 1, strValuePwr, 0, ChUnInvers);

		//  
		LCD_Draw_Rectangle_Filled(lastPxString_X, 1, LCD_Width - 1, 10, pxView_Off);
	}

	//       
	if (Settings_PA.SET_CHANGE_POWER == ON)
	{

		/*
		 * att_data   2,        dB
		 */
		Float_transform((float)att_data / 2.0, 1, &sign_number, &integer_number, &fractional_number);
		if (!sign_number)
		{
			sprintf((char*)&strValuePwr, "-%d.%.01ld\n", integer_number, fractional_number);
		}

		//  
		LCD_Draw_Line(56, 0, 56, 11, pxView_On);

		//  
		LCD_Output_String(58, 1, strValuePwr, 0, ChUnInvers);
	}
}

/*      */
void U_measurement()
{
	char strValueU[16] 	= "";
	float valueU 		= INA226_vbus();

	if(valueU != -1)
	{
		//       Float_transform
		Float_transform(valueU, 1, &sign_number, &integer_number, &fractional_number);
		if (!sign_number)
		{
			sprintf((char*)&strValueU, "U: %d.%.01ld\n", integer_number, fractional_number);
		}
		else //    
		{
			//sprintf((char*)&strValueU, "Uv: -%d.%.01ld\n", integer_number, fractional_number);
			sprintf((char*)&strValueU, "U: %d.%.01d\n", 0, 0);
		}
	}
	else
	{
		//   I2C  
		sprintf((char*)&strValueU, "U: ???\n");
	}

	// 
	LCD_Output_String(3, 37, strValueU, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 37, LCD_Width/2 - 11, 10, pxView_Off);
	//  
	LCD_Draw_Line(LCD_Width/2 - 1, 36, LCD_Width/2 - 1, 48, pxView_On);

	//,    INA226   i2c   
	/*char strValue[20] = "";
	sprintf((char*)&strValue, "addr:0x%02X\n", INA226_I2C_ADDRESS);
	// 
	LCD_Output_String(3, 50, strValue, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 50, LCD_Width - 1, 10, pxView_Off);*/
	//---
}

/*      */
void I_measurement()
{
	char strValueI[13] = "";
	//float sensitivity = 0.066f;	//0.066   30A   datasheet
	float rawVoltage;				//   0A = VCC*0.5=2.5  datasheet
	//float inpVoltage = 3.3f;		//3.3v - STM32
	float current;

	if(adc_out[0] != 0)
	{
		/*
		 *   rawVoltage      2,5 ,     ,     1,001
		 *          
		 *    -    10     5 ,      
		 */
		rawVoltage = (float)((adc_out[0] * 3.3f * 2.0f) / 4095.0f);

		current = (float)(rawVoltage - 2.5f) / 0.066f;

		//       Float_transform
		Float_transform(current, 1, &sign_number, &integer_number, &fractional_number);
		if (!sign_number)
		{
			sprintf((char*)&strValueI, "I: %d.%.01ld\n", integer_number, fractional_number);
		}
		else //    ,  0
		{
			//sprintf((char*)&strValueI, "Ia: -%d.%.01ld\n", integer_number, fractional_number);
			sprintf((char*)&strValueI, "I: %d.%.01d\n", 0, 0);
		}
	}
	else
	{
		//     ASC712
		sprintf((char*)&strValueI, "I: ???\n");
	}

	// 
	LCD_Output_String(LCD_Width/2 + 2, 37, strValueI, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 37, LCD_Width - 1, 10, pxView_Off);
	// 
	LCD_Draw_Rectangle(0, 0, LCD_Width - 1, LCD_Height - 1, pxView_On);
}

/*-----------------------------------------------------------------*/

/*       */
void LPF_label_display()
{
	uint8_t xPos;

	//     
	switch (LPF_active)
	{
		case 0: 	xPos = 96;  //160
		break;
		case 1: 	xPos = 98;  //80
		break;
		case 2: 	xPos = 98;  //40
		break;
		case 3: 	xPos = 98;  //30
		break;
		case 4: 	xPos = 98;  //20
		break;
		default:	xPos = 100; //17-10
		break;
	}

	//            
	if ((sel_work_param == 1)&&(Settings_PA.SET_EXT_CONTROL_LPF == OFF)&&(flag_ptt_on != 1))
	{
		//  
		LCD_Draw_Rectangle_Filled(87, 25, LCD_Width - 1, 10, pxView_On);
		// 
		LCD_Output_String(xPos, 25, LPF_band_string[LPF_active], 0, ChInvers);
		//  
		LCD_Draw_Rectangle_Filled(lastPxString_X, 25, LCD_Width - 1, 10, pxView_On);
	}
	else
	{
		//  
		LCD_Draw_Rectangle_Filled(87, 25, LCD_Width - 1, 10, pxView_Off);
		// 
		LCD_Output_String(xPos, 25, LPF_band_string[LPF_active], 0, ChUnInvers);
		//  
		LCD_Draw_Rectangle_Filled(lastPxString_X, 25, LCD_Width - 1, 10, pxView_Off);
	}
}

/*     */
void LPF_change_band()
{
	/*
	 *
	 *  ABCD    9-  ,    - DCBA
	 * 160m	= 0000
	 * 80m	= 1000
	 * 40m	= 0100
	 * 30m	= 1100
	 * 20m	= 0010
	 * 17m	= 1010
	 * 15m	= 0110
	 * 12m	= 1110
	 * 10m	= 0001
	 */

	//  
	LPF_active++;
	//  
	if (LPF_active > 8) {LPF_active = 0;}

	if(LPF_active == _160) //0000
	{
		A_reset();
		B_reset();
		C_reset();
		D_reset();
	}

	if(LPF_active == _80) //1000
	{
		A_set();
		B_reset();
		C_reset();
		D_reset();
	}

	if(LPF_active == _40) //0100
	{
		A_reset();
		B_set();
		C_reset();
		D_reset();
	}

	if((LPF_active == _30)||(LPF_active == _20)) //1100
	{
		A_set();
		B_set();
		C_reset();
		D_reset();
	}

	if(LPF_active == _20) //0010
	{
		A_reset();
		B_reset();
		C_set();
		D_reset();
	}

	if(LPF_active == _17) //1010
	{
		A_set();
		B_reset();
		C_set();
		D_reset();
	}

	if(LPF_active == _15) //0110
	{
		A_reset();
		B_set();
		C_set();
		D_reset();
	}

	if(LPF_active == _12) //1110
	{
		A_set();
		B_set();
		C_set();
		D_reset();
	}

	if(LPF_active == _10) //0001
	{
		A_reset();
		B_reset();
		C_reset();
		D_set();
	}
}

/*       */
void LPF_external_command()
{
	/*
	 *
	 *  ABCD    9-  ,    - DCBA
	 * 160m	= 0000
	 * 80m	= 1000
	 * 40m	= 0100
	 * 30m	= 1100
	 * 20m	= 0010
	 * 17m	= 1010
	 * 15m	= 0110
	 * 12m	= 1110
	 * 10m	= 0001
	 */

	//160
	if((!HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(!HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(!HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _160 - 1;
		LPF_change_band();
		return;
	}

	//80
	if((HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(!HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(!HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _80 - 1;
		LPF_change_band();
		return;
	}

	//40
	if((!HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(!HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _40 - 1;
		LPF_change_band();
		return;
	}

	//30
	if((HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(!HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _30 - 1;
		LPF_change_band();
		return;
	}

	//20
	if((!HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(!HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _20 - 1;
		LPF_change_band();
		return;
	}

	//17
	if((HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(!HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _17 - 1;
		LPF_change_band();
		return;
	}

	//15
	if((!HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _15 - 1;
		LPF_change_band();
		return;
	}

	//12
	if((HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(!HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _12 - 1;
		LPF_change_band();
		return;
	}

	//10
	if((!HAL_GPIO_ReadPin(A_EXT_GPIO_Port, A_EXT_Pin))&&(!HAL_GPIO_ReadPin(B_EXT_GPIO_Port, B_EXT_Pin))&&
			(!HAL_GPIO_ReadPin(C_EXT_GPIO_Port, C_EXT_Pin))&&(HAL_GPIO_ReadPin(D_EXT_GPIO_Port, D_EXT_Pin)))
	{
		LPF_active = _10 - 1;
		LPF_change_band();
		return;
	}
}

/*    PE4302 */
void PE4302_change_att(uint8_t param)
{
	static volatile uint8_t direction = 0; //

	if(param != 1)
	{
		//        
		if(direction == 0) {att_data++;}
		if(direction == 1) {att_data--;}
	}

	//           PE4302 V1...V6
	if(att_data & (1<<0)) {PE_V1_set();} else {PE_V1_reset();}
	if(att_data & (1<<1)) {PE_V2_set();} else {PE_V2_reset();}
	if(att_data & (1<<2)) {PE_V3_set();} else {PE_V3_reset();}
	if(att_data & (1<<3)) {PE_V4_set();} else {PE_V4_reset();}
	if(att_data & (1<<4)) {PE_V5_set();} else {PE_V5_reset();}
	if(att_data & (1<<5)) {PE_V6_set();} else {PE_V6_reset();}

	if(param != 1)
	{
		//     
		if(att_data >= 63) {direction = 1;}
		if(att_data <= 0) {direction = 0;}
	}
}

/*-----------------------------------------------------------------*/

/*      */
void DISPLAY_work()
{
	// 
	LCD_Draw_Rectangle(0, 0, LCD_Width - 1, LCD_Height - 1, pxView_On);
	//  
	LCD_Output_String(3, 0, "\n", 0, ChUnInvers);
	//  
	LCD_Draw_Line(0, 12, LCD_Width - 1, 12, pxView_On);
	//  
	LCD_Output_String(3, 13, "\n", 0, ChUnInvers);
	//  
	LCD_Draw_Line(0, 24, LCD_Width - 1, 24, pxView_On);
	//  
	LCD_Output_String(3, 25, " \n", 0, ChUnInvers);
	//  
	LCD_Draw_Line(0, 36, LCD_Width - 1, 36, pxView_On);
	//  
	LCD_Draw_Line(86, 0, 86, 36, pxView_On);
	//  
	LCD_Draw_Line(LCD_Width/2 - 1, 36, LCD_Width/2 - 1, 48, pxView_On);
	//  
	LCD_Draw_Line(0, 48, LCD_Width - 1, 48, pxView_On);
}

/*     */
void READ_setup_pa()
{
	Settings_PA.SET_LED_DISPLAY		= ON;
	Settings_PA.SET_CHANGE_POWER	= ON;
	Settings_PA.SET_EXT_CONTROL_LPF	= ON;
	Settings_PA.SET_Z				= _50;

	LED_display(Settings_PA.SET_LED_DISPLAY);
}

/*-----------------------------------------------------------------*/

/*       */
void MENU_move(uint8_t sel_param)
{
	for (uint8_t i = 0; i < 4; i++)
	{
		if (sel_param != i)
		{
			//     
			LCD_Output_String(0, (i + 1) * 12, MENU_index[i], 0, ChUnInvers);

			//      
			if (i == 0)
			{
				if (Settings_PA.SET_LED_DISPLAY == ON)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[0], 0, ChUnInvers);
				}
				else if (Settings_PA.SET_LED_DISPLAY == OFF)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[1], 0, ChUnInvers);
				}
			}
			else if (i == 1)
			{
				if (Settings_PA.SET_CHANGE_POWER == ON)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[0], 0, ChUnInvers);
				}
				else if (Settings_PA.SET_CHANGE_POWER == OFF)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[1], 0, ChUnInvers);
				}
			}
			else if (i == 2)
			{
				if (Settings_PA.SET_EXT_CONTROL_LPF == ON)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[i + 1], 0, ChUnInvers);
				}
				else if (Settings_PA.SET_EXT_CONTROL_LPF == OFF)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[i], 0, ChUnInvers);
				}
			}
			else if (i == 3)
			{
				char strValuePwr[5] = "";
				sprintf((char*)&strValuePwr, "%d\n", Settings_PA.SET_Z);
				LCD_Output_String(100, (i + 1) * 12, strValuePwr, 0, ChUnInvers);
			}
		}
		else
		{
			//    
			LCD_Output_String(0, (i + 1) * 12, MENU_index[i], 0, ChInvers);

			//     
			LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, 99, 9, pxView_On);

			//     
			if (i == 0)
			{
				if (Settings_PA.SET_LED_DISPLAY == ON)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[0], 0, ChInvers);
					//     
					LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, LCD_Width - 1, 9, pxView_On);
				}
				else if (Settings_PA.SET_LED_DISPLAY == OFF)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[1], 0, ChInvers);
					//     
					LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, LCD_Width - 1, 9, pxView_On);
				}
			}
			else if (i == 1)
			{
				if (Settings_PA.SET_CHANGE_POWER == ON)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[0], 0, ChInvers);
					//   
					LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, LCD_Width - 1, 9, pxView_On);
				}
				else if (Settings_PA.SET_CHANGE_POWER == OFF)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[1], 0, ChInvers);
					//   
					LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, LCD_Width - 1, 9, pxView_On);
				}
			}
			else if (i == 2)
			{
				if (Settings_PA.SET_EXT_CONTROL_LPF == ON)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[i + 1], 0, ChInvers);
					//   
					LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, LCD_Width - 1, 9, pxView_On);

				}
				else if (Settings_PA.SET_EXT_CONTROL_LPF == OFF)
				{
					LCD_Output_String(100, (i + 1) * 12, MENU_param_index[i], 0, ChInvers);
					//   
					LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, LCD_Width - 1, 9, pxView_On);
				}
			}
			else if (i == 3)
			{
				char strValuePwr[5] = "";
				sprintf((char*)&strValuePwr, "%d\n", Settings_PA.SET_Z);
				LCD_Output_String(100, (i + 1) * 12, strValuePwr, 0, ChInvers);
				//   
				LCD_Draw_Rectangle_Filled(lastPxString_X, ((i + 1) * 12) + 1, LCD_Width - 1, 9, pxView_On);
			}
		}
	}

	LCD_Update();
}

/*        */
void FILL_sel_param(uint8_t yPos)
{
	LCD_Draw_Rectangle_Filled(lastPxString_X, yPos, LCD_Width - 1, 9, pxView_On);
}

/*      */
void MENU_change_param(uint8_t sel_param)
{
	if (sel_param == 0)	// 
	{
		if (Settings_PA.SET_LED_DISPLAY == ON)
		{
			//     
			Settings_PA.SET_LED_DISPLAY = OFF;
			//     
			LCD_Output_String(100, 12, MENU_param_index[0], 0, ChInvers);
		}
		else if (Settings_PA.SET_LED_DISPLAY == OFF)
		{
			//     
			Settings_PA.SET_LED_DISPLAY = ON;
			//     
			LCD_Output_String(100, 12, MENU_param_index[1], 0, ChInvers);
		}

		//   
		FILL_sel_param(11);

		//   
		LED_display(Settings_PA.SET_LED_DISPLAY);
	}
	else if (sel_param == 1) //    
	{
		if (Settings_PA.SET_CHANGE_POWER == ON)
		{
			//     
			Settings_PA.SET_CHANGE_POWER = OFF;
			//     
			LCD_Output_String(100, 24, MENU_param_index[0], 0, ChInvers);
		}
		else if (Settings_PA.SET_CHANGE_POWER == OFF)
		{
			//     
			Settings_PA.SET_CHANGE_POWER = ON;
			//     
			LCD_Output_String(100, 24, MENU_param_index[1], 0, ChInvers);
		}

		//   
		FILL_sel_param(24);
	}
	else if (sel_param == 2) // 
	{
		if (Settings_PA.SET_EXT_CONTROL_LPF == ON)
		{
			//     
			Settings_PA.SET_EXT_CONTROL_LPF = OFF;
			//     
			LCD_Output_String(100, 36, MENU_param_index[0], 0, ChInvers);
		}
		else if (Settings_PA.SET_EXT_CONTROL_LPF == OFF)
		{
			//     
			Settings_PA.SET_EXT_CONTROL_LPF = ON;
			//     
			LCD_Output_String(100, 36, MENU_param_index[1], 0, ChInvers);
		}

		//   
		FILL_sel_param(36);
	}
	else if (sel_param == 3) // 
	{

		if (Settings_PA.SET_Z == _50)
		{
			Settings_PA.SET_Z = _75;
		}
		else if (Settings_PA.SET_Z == _75)
		{
			Settings_PA.SET_Z = _50;
		}
		char strValuePwr[5] = "";
		sprintf((char*)&strValuePwr, "%d\n", Settings_PA.SET_Z);
		LCD_Output_String(100, 48, strValuePwr, 0, ChInvers);

		//   
		FILL_sel_param(48);
	}
}

/*     */
void CALIBRATE_param()
{
	char strValue[15] = "";

	/*     INA226 */
	float valueU = INA226_vbus();
	if(valueU != -1)
	{
		//       Float_transform
		Float_transform(valueU, 2, &sign_number, &integer_number, &fractional_number);
		if (!sign_number)
		{
			sprintf((char*)&strValue, "%d.%.02ld\n", integer_number, fractional_number);
		}
		else //    
		{
			sprintf((char*)&strValue, "%d.%.02ld\n", integer_number, fractional_number);
		}
	}
	else
	{
		//   I2C  
		sprintf((char*)&strValue, "???\n");
	}
	//   
	LCD_Draw_Rectangle_Filled(90, 13, 95, 9, pxView_On);
	// 
	LCD_Output_String(95, 12, strValue, 0, ChInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 13, LCD_Width/2 - 11, 9, pxView_On);

	//  strValue
	for(uint8_t i = 0; i < 7; i++) {strValue[i] = 0;}

	/*     ASC712 */
	//float sensitivity = 0.066f;	//0.066   30A   datasheet
	float rawVoltage;				//   0A = VCC*0.5=2.5  datasheet
	//float inpVoltage = 3.3f;		//3.3v - STM32
	float current;

	if(adc_out[0] != 0)
	{
		/*
		 *   rawVoltage      2,5 ,     ,     1,001
		 *          
		 *    -    10     5 ,        
		 */
		rawVoltage = (float)adc_out[0] * 3.3 * 2.0 / 4095.0;

		current = (float)(rawVoltage - 2.5) / 0.066;

		//       Float_transform
		Float_transform(current, 2, &sign_number, &integer_number, &fractional_number);
		if (!sign_number)
		{
			sprintf((char*)&strValue, "%d.%.02ld\n", integer_number, fractional_number);
		}
		else //  
		{
			sprintf((char*)&strValue, "-%d.%.02ld\n", integer_number, fractional_number);
		}
	}
	else
	{
		//     ASC712
		sprintf((char*)&strValue, "???\n");
	}

	// 
	LCD_Output_String(95, 24, strValue, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 24, LCD_Width - 1, 10, pxView_Off);

	//  strValue
	for(uint8_t i = 0; i < sizeof(strValue); i++) {strValue[i] = 0;}

	// / 
	GET_power();

	//   FOR
	Float_transform(rawFor, 2, &sign_number, &integer_number, &fractional_number); // FOR
	if (!sign_number)
	{
		sprintf((char*)&strValue, "U: %d.%.02ld\n", integer_number, fractional_number);
	}

	// 
	LCD_Output_String(1, 38, strValue, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 38, LCD_Width - 1, 10, pxView_Off);

	//  strValue
	for(uint8_t i = 0; i < sizeof(strValue); i++) {strValue[i] = 0;}

	//   FOR
	Float_transform(powerFor, 2, &sign_number, &integer_number, &fractional_number); //  FOR
	if (!sign_number)
	{
		sprintf((char*)&strValue, "P: %d.%.02ld\n", integer_number, fractional_number);
	}

	// 
	LCD_Output_String(64, 38, strValue, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 38, LCD_Width - 1, 10, pxView_Off);

	//  strValue
	for(uint8_t i = 0; i < sizeof(strValue); i++) {strValue[i] = 0;}

	//   FOR
	Float_transform(rawRef, 2, &sign_number, &integer_number, &fractional_number); // FOR
	if (!sign_number)
	{
		sprintf((char*)&strValue, "U: %d.%.02ld\n", integer_number, fractional_number);
	}

	// 
	LCD_Output_String(1, 50, strValue, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 50, LCD_Width - 1, 10, pxView_Off);

	//  strValue
	for(uint8_t i = 0; i < sizeof(strValue); i++) {strValue[i] = 0;}

	//   FOR
	Float_transform(powerRef, 2, &sign_number, &integer_number, &fractional_number); //  FOR
	if (!sign_number)
	{
		sprintf((char*)&strValue, "P: %d.%.02ld\n", integer_number, fractional_number);
	}

	// 
	LCD_Output_String(64, 50, strValue, 0, ChUnInvers);
	//  
	LCD_Draw_Rectangle_Filled(lastPxString_X, 50, LCD_Width - 1, 10, pxView_Off);

	// 
	LCD_Update();
}

/*-----------------------------------------------------------------*/

/*     */
void PROG_mode()
{
	switch (PROG_state)
	{
		// 
		case PROG_STATE_WORK:  PROG_mode_work();
		break;
		// 
		case PROG_STATE_SETUP: PROG_mode_setup();
		break;
		// 
		case PROG_STATE_CALIBRATE: PROG_mode_calibrate();
		break;
	}
}

/*    -  */
void PROG_mode_work()
{
	/*   */
	LCD_Clean_Buffer_Frame();
	DISPLAY_work();

	/*    */
	while(1)
	{
		if((!flag_ptt_on)&&(Settings_PA.SET_EXT_CONTROL_LPF != OFF))
		{
			//   ABCD,     
			LPF_external_command();
		}

		if(end_adc_flag == 1)
		{
			//  -1
			ADC_1_start_conversion();
		}

		// 
		U_measurement();

		if(end_adc_filter_flag == 1)
		{
			//   
			POWER_measurement();

			//  
			I_measurement();
		}

		//    
		LPF_label_display();

		// 
		READ_button();

		/*    */
		if ((BUT_press == BUT_RIGHT)&&(flag_ptt_on != 1))
		{
			/*
			 *    
			 *    
			 *         ">"
			 *    
			 *   ,       
			 */
			sel_work_param++;
			if (sel_work_param > 1) {sel_work_param = 0;}
			BUT_press = NO_BUT;
			return;
		}

		if ((BUT_press == BUT_LEFT))
		{
			/*    */

			if ((sel_work_param == 0)&&(flag_ptt_on != 0))
			{
				/*    (    )
				 *            
				 *        
				 */
				if (Settings_PA.SET_CHANGE_POWER == ON) {PE4302_change_att(0);}
			}
			else if ((sel_work_param == 1)&&(flag_ptt_on != 1)&&(Settings_PA.SET_EXT_CONTROL_LPF != ON))
			{
				//   
				//    
				LPF_change_band();
			}

			BUT_press = NO_BUT;
			return;
		}

		if ((BUT_press == BUT_FUNCTION)&&(flag_ptt_on != 1))
		{
			//    
			PROG_state = PROG_STATE_SETUP;
			BUT_press = NO_BUT;
			return;
		}

		// 
		LCD_Draw_Rectangle(0, 0, LCD_Width - 1, LCD_Height - 1, pxView_On);
		// 
		LCD_Update();
	}
}

/*    -  */
void PROG_mode_setup()
{
	/*   */
	LCD_Clean_Buffer_Frame();
	LCD_Output_String(0, 0, ":\n", 0, ChUnInvers);
	//  
	LCD_Draw_Line(0, 11, LCD_Width - 1, 11, pxView_On);
	LCD_Draw_Line(0, LCD_Height - 1, LCD_Width - 1, LCD_Height - 1, pxView_On);
	/*   */
	MENU_move(sel_param);

	/*    */
	while(1)
	{
		if((!flag_ptt_on)&&(Settings_PA.SET_EXT_CONTROL_LPF != OFF))
		{
			//   ABCD,     
			LPF_external_command();
		}

		if(end_adc_flag == 1)
		{
			//  -1
			ADC_1_start_conversion();
		}

		//  
		READ_button();

		/*      */
		if (BUT_press == BUT_RIGHT)
		{
			sel_param++;
			if (sel_param > 3) {sel_param = 0;}
			MENU_move(sel_param);
			BUT_press = NO_BUT;
			return;
		}

		/*       */
		if (BUT_press == BUT_LEFT)
		{
			MENU_change_param(sel_param);
			BUT_press = NO_BUT;
			return;
		}

		/*     */
		if ((BUT_press == BUT_FUNCTION)&&(flag_ptt_on != 1))
		{
			PROG_state = PROG_STATE_CALIBRATE;
			BUT_press = NO_BUT;
			return;
		}
	}
}

/*    -  */
void PROG_mode_calibrate()
{
	/*   */
	LCD_Clean_Buffer_Frame();
	LCD_Output_String(0, 0, ":\n", 0, ChUnInvers);
	//  
	LCD_Draw_Line(0, 11, LCD_Width - 1, 11, pxView_On);
	LCD_Draw_Line(0, 36, LCD_Width - 1, 36, pxView_On);
	LCD_Draw_Line(0, LCD_Height - 1, LCD_Width - 1, LCD_Height - 1, pxView_On);
	//  
	LCD_Output_String(0, 12, CALIBRATE_index[0], 0, ChUnInvers);
	LCD_Output_String(0, 24, CALIBRATE_index[1], 0, ChUnInvers);

	/*    */
	while(1)
	{
		if((!flag_ptt_on)&&(Settings_PA.SET_EXT_CONTROL_LPF != OFF))
		{
			//   ABCD,     
			LPF_external_command();
		}

		if(end_adc_flag == 1)
		{
			//  -1
			ADC_1_start_conversion();
		}

		if(end_adc_filter_flag == 1)
		{
			//  
			CALIBRATE_param();
		}

		//  
		READ_button();

		// VBUS  
		if (BUT_press == BUT_RIGHT)
		{
			vbus_calibrate = vbus_calibrate + 0.1f;
			if (vbus_calibrate > 200) {vbus_calibrate = 0;}
			BUT_press = NO_BUT;
			return;
		}

		// VBUS  
		if (BUT_press == BUT_LEFT)
		{
			vbus_calibrate = vbus_calibrate - 0.1f;
			if (vbus_calibrate < -200) {vbus_calibrate = 0;}
			BUT_press = NO_BUT;
			return;
		}

		//   
		if ((BUT_press == BUT_FUNCTION)&&(flag_ptt_on != 1))
		{
			PROG_state = PROG_STATE_WORK;
			BUT_press = NO_BUT;
			return;
		}
	}
}

/*-----------------------------------------------------------------*/

/*    */
void Splash()
{
	// 
	LCD_Output_String(0, 0, _PROGRAM_DEF, 0, ChUnInvers);
	LCD_Output_String(0, 24, _RELEASE_DEF, 0, ChUnInvers);
	LCD_Output_String(0, 53, _COPYRIGHT_DEF, 0, ChUnInvers);
	LCD_Update();
	// 
	HAL_Delay(3000);
	LCD_Clean_Buffer_Frame();
	LCD_Update();
}

/*-----------------------------------------------------------------*/
